'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = getScopeBit;

var _consumer;

function _load_consumer() {
  return _consumer = require('../../../consumer');
}

var _scope;

function _load_scope() {
  return _scope = require('../../../scope');
}

var _bitId;

function _load_bitId() {
  return _bitId = require('../../../bit-id');
}

function getScopeBit(_ref) {
  let id = _ref.id,
      loader = _ref.loader,
      allVersions = _ref.allVersions;

  return (0, (_consumer || _load_consumer()).loadConsumer)().then(consumer => {
    const localScopeName = consumer.scope.name;
    const bitId = (_bitId || _load_bitId()).BitId.parse(id, localScopeName);
    if (!bitId.isLocal(localScopeName)) {
      if (allVersions) {
        return Promise.reject(new Error('cant list all versions of a remote scope'));
      }

      return consumer.scope.remotes().then(remotes => remotes.resolve(bitId.scope, consumer.scope).then(remote => {
        loader.start();
        return remote.show(bitId);
      }));
    }

    if (allVersions) {
      return consumer.scope.loadAllVersions(bitId);
    }
    return consumer.scope.loadComponent(bitId);
  }).catch(err => {
    // TODO - handle relevant error error
    return (0, (_scope || _load_scope()).loadScope)(process.cwd()).then(scope => {
      const localScopeName = scope.name;
      const bitId = (_bitId || _load_bitId()).BitId.parse(id, localScopeName);
      if (allVersions) {
        return scope.loadAllVersions(bitId);
      }
      return scope.loadComponent(bitId);
    });
  });
}