'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = list;

var _consumer;

function _load_consumer() {
  return _consumer = require('../../../consumer');
}

var _scope;

function _load_scope() {
  return _scope = require('../../../scope');
}

function list(_ref) {
  let scopeName = _ref.scopeName,
      loader = _ref.loader;

  return (0, (_consumer || _load_consumer()).loadConsumer)().then(consumer => {
    const scope = consumer.scope;

    if (scopeName) {
      return scope.remotes().then(remotes =>
      // $FlowFixMe
      remotes.resolve(scopeName, scope.name).then(remote => {
        loader.start();
        return remote.list();
      }));
    }

    return scope.listStage();
  }).catch(err => {
    // handle relevant error error
    return (0, (_scope || _load_scope()).loadScope)(process.cwd()).then(scope => scope.listStage());
  });
}