'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.resetResolver = exports.getResolver = exports.setResolver = undefined;

var _scope;

function _load_scope() {
  return _scope = require('../../../scope');
}

const setResolver = exports.setResolver = (currentPath, resolverPath) => {
  return (0, (_scope || _load_scope()).loadScope)(currentPath).then(scope => {
    scope.scopeJson.resolverPath = resolverPath;
    return scope.scopeJson.write(scope.getPath());
  });
};

const getResolver = exports.getResolver = currentPath => {
  return (0, (_scope || _load_scope()).loadScope)(currentPath).then(scope => scope.scopeJson.resolverPath);
};

const resetResolver = exports.resetResolver = currentPath => {
  return (0, (_scope || _load_scope()).loadScope)(currentPath).then(scope => {
    scope.scopeJson.resolverPath = null;
    return scope.scopeJson.write(scope.getPath());
  });
};