'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _ramda;

function _load_ramda() {
  return _ramda = require('ramda');
}

var _bitId;

function _load_bitId() {
  return _bitId = require('../bit-id');
}

var _utils;

function _load_utils() {
  return _utils = require('../utils');
}

class BitIds extends Array {
  serialize() {
    return this.map(bitId => bitId.toString());
  }

  toObject() {
    return (0, (_ramda || _load_ramda()).mergeAll)(this.map(bitId => bitId.toObject()));
  }

  static deserialize() {
    let array = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];

    return new BitIds(...array.map(id => (_bitId || _load_bitId()).BitId.parse(id)));
  }

  static fromObject(dependencies) {
    const array = [];

    (0, (_utils || _load_utils()).forEach)(dependencies, (version, id) => {
      array.push((_bitId || _load_bitId()).BitId.parse(id, null, version));
    });

    return new BitIds(...array);
  }
}
exports.default = BitIds;