'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _command;

function _load_command() {
  return _command = _interopRequireDefault(require('../../command'));
}

var _utils;

function _load_utils() {
  return _utils = require('../../../utils');
}

var _search;

function _load_search() {
  return _search = require('../../../search');
}

var _indexer;

function _load_indexer() {
  return _indexer = require('../../../search/indexer');
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

class Search extends (_command || _load_command()).default {
  constructor() {
    var _temp;

    return _temp = super(...arguments), this.name = '_search <path> <query> <reindex>', this.private = true, this.description = 'search for components on a remote scope', this.alias = '', this.opts = [], _temp;
  }

  action(_ref) {
    var _ref2 = _slicedToArray(_ref, 3);

    let path = _ref2[0],
        query = _ref2[1],
        reindex = _ref2[2];

    return (_search || _load_search()).searchAdapter.scopeSearch((0, (_utils || _load_utils()).fromBase64)(path), (0, (_utils || _load_utils()).fromBase64)(query), (0, (_utils || _load_utils()).fromBase64)(reindex) === 'true');
  }

  report(searchResults) {
    return JSON.stringify(searchResults);
  }
}
exports.default = Search;