'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _chalk;

function _load_chalk() {
  return _chalk = _interopRequireDefault(require('chalk'));
}

var _command;

function _load_command() {
  return _command = _interopRequireDefault(require('../../command'));
}

var _scope;

function _load_scope() {
  return _scope = require('../../../api/scope');
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

class ResolverSet extends (_command || _load_command()).default {
  constructor() {
    var _temp;

    return _temp = super(...arguments), this.name = 'set <resolverPath>', this.description = 'set remote resolver to scope (use from scope directory)', this.alias = 's', this.private = true, this.opts = [], _temp;
  }

  action(_ref) {
    var _ref2 = _slicedToArray(_ref, 1);

    let resolverPath = _ref2[0];

    if (!resolverPath) {
      // @TODO mandatory arguments do not work for sub commands - please fix !
      throw new Error('resolverPath is mandatory');
    }

    return (0, (_scope || _load_scope()).setResolver)(process.cwd(), resolverPath).then(() => resolverPath);
  }

  report(resolverPath) {
    return `resovler path has changed sucessfully to - ${(_chalk || _load_chalk()).default.yellow(resolverPath)}`;
  }
}

class ResolverReset extends (_command || _load_command()).default {
  constructor() {
    var _temp2;

    return _temp2 = super(...arguments), this.name = 'reset', this.description = 'reset remote resolver to default resolver', this.alias = 'r', this.opts = [], _temp2;
  }

  action() {
    return (0, (_scope || _load_scope()).resetResolver)(process.cwd());
  }

  report() {
    return 'resovler path has successfully reset to deafult';
  }
}

class Resolver extends (_command || _load_command()).default {
  constructor() {
    var _temp3;

    return _temp3 = super(...arguments), this.name = 'resolver', this.description = 'get or set remote resolver to scope', this.alias = '', this.opts = [], this.commands = [new ResolverSet(), new ResolverReset()], this.private = true, _temp3;
  }

  action() {
    return (0, (_scope || _load_scope()).getResolver)(process.cwd());
  }

  report(resovlerPath) {
    if (!resovlerPath) {
      return 'there is no resolver path, bit uses the default resolver';
    }

    return (_chalk || _load_chalk()).default.yellow(resovlerPath);
  }
}
exports.default = Resolver;