'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _command;

function _load_command() {
  return _command = _interopRequireDefault(require('../../command'));
}

var _utils;

function _load_utils() {
  return _utils = require('../../../utils');
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// import { config } from '../../../api/consumer';
const config = require('../../../api/consumer/lib/global-config');

class Config extends (_command || _load_command()).default {
  constructor() {
    var _temp;

    return _temp = super(...arguments), this.name = 'config', this.description = 'global config management', this.alias = '', this.commands = [new ConfigSet(), new ConfigDel(), new ConfigGet(), new ConfigList()], this.opts = [], _temp;
  }

  action() {
    return config.list();
  }

  report(conf) {
    return (0, (_utils || _load_utils()).objectToTupleArray)(conf).map(tuple => {
      return tuple.join('     ');
    }).join('\n');
  }
}

exports.default = Config;
class ConfigSet extends (_command || _load_command()).default {
  constructor() {
    var _temp2;

    return _temp2 = super(...arguments), this.name = 'set <key> <val>', this.description = 'set a glboal configuration', this.alias = '', this.opts = [], _temp2;
  }

  action(_ref) {
    var _ref2 = _slicedToArray(_ref, 2);

    let key = _ref2[0],
        value = _ref2[1];

    return config.set(key, value);
  }

  report(conf) {
    return 'added configuration successfully';
  }
}

class ConfigGet extends (_command || _load_command()).default {
  constructor() {
    var _temp3;

    return _temp3 = super(...arguments), this.name = 'get <key>', this.description = 'get a glboal configuration', this.alias = '', this.opts = [], _temp3;
  }

  action(_ref3) {
    var _ref4 = _slicedToArray(_ref3, 1);

    let key = _ref4[0];

    return config.get(key);
  }

  report(value) {
    return value;
  }
}

class ConfigList extends (_command || _load_command()).default {
  constructor() {
    var _temp4;

    return _temp4 = super(...arguments), this.name = 'list', this.description = 'list all configuration(s)', this.alias = '', this.opts = [], _temp4;
  }

  action() {
    return config.list();
  }

  report(conf) {
    return (0, (_utils || _load_utils()).objectToTupleArray)(conf).map(tuple => {
      return tuple.join('     ');
    }).join('\n');
  }
}

class ConfigDel extends (_command || _load_command()).default {
  constructor() {
    var _temp5;

    return _temp5 = super(...arguments), this.name = 'del <key>', this.description = 'delete given key from global configuration', this.alias = '', this.opts = [], _temp5;
  }

  action(_ref5) {
    var _ref6 = _slicedToArray(_ref5, 1);

    let key = _ref6[0];

    return config.del(key);
  }

  report(conf) {
    return 'deleted successfully';
  }
}