'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _command;

function _load_command() {
  return _command = _interopRequireDefault(require('../../command'));
}

var _consumer;

function _load_consumer() {
  return _consumer = require('../../../api/consumer');
}

var _component;

function _load_component() {
  return _component = _interopRequireDefault(require('../../../consumer/component'));
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const chalk = require('chalk');

class Create extends (_command || _load_command()).default {
  constructor() {
    var _temp;

    return _temp = super(...arguments), this.name = 'create <id>', this.description = 'create a new component', this.alias = 'cr', this.opts = [['s', 'specs', 'create specs file automatically'], ['j', 'json', 'create bit.json file automatically']], _temp;
  }

  action(_ref, _ref2) {
    var _ref3 = _slicedToArray(_ref, 1);

    let id = _ref3[0];
    let specs = _ref2.specs,
        json = _ref2.json;

    return (0, (_consumer || _load_consumer()).create)(id, specs, json);
  }

  report(component) {
    const name = component.name;
    const box = component.box;

    return chalk.green(`created component "${name}" in box "${box}"`);
  }
}
exports.default = Create;