'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _ramda;

function _load_ramda() {
  return _ramda = _interopRequireDefault(require('ramda'));
}

var _chalk;

function _load_chalk() {
  return _chalk = _interopRequireDefault(require('chalk'));
}

var _command;

function _load_command() {
  return _command = _interopRequireDefault(require('../../command'));
}

var _consumer;

function _load_consumer() {
  return _consumer = require('../../../api/consumer');
}

var _component;

function _load_component() {
  return _component = _interopRequireDefault(require('../../../consumer/component'));
}

var _chalkBox;

function _load_chalkBox() {
  return _chalkBox = require('../../chalk-box');
}

var _listTemplate;

function _load_listTemplate() {
  return _listTemplate = _interopRequireDefault(require('../../templates/list-template'));
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

class List extends (_command || _load_command()).default {
  constructor() {
    var _temp;

    return _temp = super(...arguments), this.name = 'list [scope]', this.description = 'list all scope components', this.alias = 'ls', this.opts = [['i', 'inline', 'in inline components'], ['ids', 'ids', 'in inline components']], this.loader = { autoStart: false, text: 'listing remote components' }, _temp;
  }

  action(_ref, _ref2) {
    var _ref3 = _slicedToArray(_ref, 1);

    let scopeName = _ref3[0];
    let inline = _ref2.inline,
        ids = _ref2.ids;

    const loader = this.loader;

    function list() {
      if (inline) return (0, (_consumer || _load_consumer()).listInline)();
      return (0, (_consumer || _load_consumer()).listScope)({ scopeName, loader });
    }

    return list().then(components => ({
      components,
      scope: scopeName,
      inline,
      ids
    }));
  }

  report(_ref4) {
    let components = _ref4.components,
        scope = _ref4.scope,
        inline = _ref4.inline,
        ids = _ref4.ids;

    function decideHeaderSentence() {
      if (inline) return `Total ${components.length} components in inline directory`;
      if (!scope) return `Total ${components.length} components in local scope`;
      return `Total ${components.length} components in ${scope}`;
    }

    if ((_ramda || _load_ramda()).default.isEmpty(components)) {
      return (_chalk || _load_chalk()).default.white(`${decideHeaderSentence()}`);
    }
    if (ids) return JSON.stringify(components.map(c => c.id.toString()));
    // TODO - use a cheaper list for ids flag (do not fetch versions at all) @!IMPORTANT
    return (0, (_chalkBox || _load_chalkBox()).paintHeader)(decideHeaderSentence()) + (0, (_listTemplate || _load_listTemplate()).default)(components);
  }
}
exports.default = List;