'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _chalk;

function _load_chalk() {
  return _chalk = _interopRequireDefault(require('chalk'));
}

var _command;

function _load_command() {
  return _command = _interopRequireDefault(require('../../command'));
}

var _consumer;

function _load_consumer() {
  return _consumer = require('../../../api/consumer');
}

var _utils;

function _load_utils() {
  return _utils = require('../../../utils');
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

class Remote extends (_command || _load_command()).default {
  constructor() {
    var _temp;

    return _temp = super(...arguments), this.name = 'remote', this.description = 'manage set of tracked bit scope(s)', this.alias = '', this.opts = [['g', 'global', 'see globally configured remotes']], this.commands = [new RemoteAdd(), new RemoteRm()], _temp;
  }

  // $FlowFixMe
  action(args, _ref) {
    let global = _ref.global;

    return (0, (_consumer || _load_consumer()).remoteList)(global);
  }

  report(remotes) {
    if ((0, (_utils || _load_utils()).empty)(remotes)) return (_chalk || _load_chalk()).default.red('no configured remotes found in scope');
    const resArr = ['scope name | host'];
    (0, (_utils || _load_utils()).forEach)(remotes, (host, name) => {
      resArr.push(`${name} | ${host}`);
    });
    return resArr.join('\n');
  }
}

exports.default = Remote;
class RemoteAdd extends (_command || _load_command()).default {
  constructor() {
    var _temp2;

    return _temp2 = super(...arguments), this.name = 'add <url>', this.description = 'add a tracked bit remote', this.alias = '', this.opts = [['g', 'global', 'configure a remote bit scope']], _temp2;
  }

  action(_ref2, _ref3) {
    var _ref4 = _slicedToArray(_ref2, 1);

    let url = _ref4[0];
    let global = _ref3.global;

    return (0, (_consumer || _load_consumer()).remoteAdd)(url, global);
  }

  report(_ref5) {
    let name = _ref5.name,
        host = _ref5.host;

    return (_chalk || _load_chalk()).default.green(`added remote scope '${(_chalk || _load_chalk()).default.bold(name)}' with host '${(_chalk || _load_chalk()).default.bold(host)}'`);
  }
}

class RemoteRm extends (_command || _load_command()).default {
  constructor() {
    var _temp3;

    return _temp3 = super(...arguments), this.name = 'rm <name>', this.description = 'remove a tracked bit remote', this.alias = '', this.opts = [['g', 'global', 'remove a global configured remote scope']], _temp3;
  }

  action(_ref6, _ref7) {
    var _ref8 = _slicedToArray(_ref6, 1);

    let name = _ref8[0];
    let global = _ref7.global;

    return (0, (_consumer || _load_consumer()).remoteRm)(name, global);
  }

  report(name) {
    return (_chalk || _load_chalk()).default.green(`successfully removed remote ${(_chalk || _load_chalk()).default.bold(name)}`);
  }
}