'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _chalk;

function _load_chalk() {
  return _chalk = _interopRequireDefault(require('chalk'));
}

var _command;

function _load_command() {
  return _command = _interopRequireDefault(require('../../command'));
}

var _search;

function _load_search() {
  return _search = require('../../../search');
}

var _searcher;

function _load_searcher() {
  return _searcher = require('../../../search/searcher');
}

var _indexer;

function _load_indexer() {
  return _indexer = require('../../../search/indexer');
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

class Search extends (_command || _load_command()).default {
  constructor() {
    var _temp;

    return _temp = super(...arguments), this.name = 'search <scope> <query...>', this.description = 'search for components', this.alias = '', this.opts = [['r', 'reindex', 're-index all components']], this.loader = { autoStart: false }, _temp;
  }

  action(_ref, _ref2) {
    var _ref3 = _slicedToArray(_ref, 2);

    let scope = _ref3[0],
        query = _ref3[1];
    let reindex = _ref2.reindex;

    const queryStr = query.join(' ');
    if (scope !== '@this') {
      // $FlowFixMe
      this.loader.text = `searching remote scope <${scope}> for '${queryStr}'`;
      // $FlowFixMe
      this.loader.start();
      return (_search || _load_search()).searchAdapter.searchRemotely(queryStr, scope, reindex);
    }

    return (_search || _load_search()).searchAdapter.searchLocally(queryStr, reindex);
  }

  report(searchResults) {
    if (!searchResults.length) {
      return (_chalk || _load_chalk()).default.red('No Results');
    }
    return (_chalk || _load_chalk()).default.green(searchResults.map((_searcher || _load_searcher()).formatter).join('\n'));
  }
}
exports.default = Search;