'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _command;

function _load_command() {
  return _command = _interopRequireDefault(require('../../command'));
}

var _consumer;

function _load_consumer() {
  return _consumer = require('../../../api/consumer');
}

var _scope;

function _load_scope() {
  return _scope = require('../../../api/scope');
}

var _chalkBox;

function _load_chalkBox() {
  return _chalkBox = require('../../chalk-box');
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

class Test extends (_command || _load_command()).default {
  constructor() {
    var _temp;

    return _temp = super(...arguments), this.name = 'test <id>', this.description = 'run component(s) unit tests', this.alias = 't', this.opts = [['i', 'inline', 'test an inline component specs']], _temp;
  }

  action(_ref, _ref2) {
    var _ref3 = _slicedToArray(_ref, 1);

    let id = _ref3[0];
    let inline = _ref2.inline;

    function build() {
      if (inline) return (0, (_consumer || _load_consumer()).testInline)(id);
      return (0, (_scope || _load_scope()).testInScope)(id);
    }

    return build().then(res => ({
      res,
      inline
    }));
  }

  report(_ref4) {
    let res = _ref4.res,
        inline = _ref4.inline;

    if (res) {
      return (0, (_chalkBox || _load_chalkBox()).paintSpecsResults)(res);
    }

    return 'couldn\'t get test results...';
  }
}
exports.default = Test;