'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }(); // all errors that the command does not handle comes to this switch statement
// if you handle the error, then return true


var _bitNotFound;

function _load_bitNotFound() {
  return _bitNotFound = _interopRequireDefault(require('../consumer/component/exceptions/bit-not-found'));
}

var _invalidBitId;

function _load_invalidBitId() {
  return _invalidBitId = _interopRequireDefault(require('../bit-id/exceptions/invalid-bit-id'));
}

var _bitAlreadyExistExternaly;

function _load_bitAlreadyExistExternaly() {
  return _bitAlreadyExistExternaly = _interopRequireDefault(require('../consumer/component/exceptions/bit-already-exist-externaly'));
}

var _exceptions;

function _load_exceptions() {
  return _exceptions = require('../consumer/exceptions');
}

var _pluginNotFound;

function _load_pluginNotFound() {
  return _pluginNotFound = _interopRequireDefault(require('../consumer/component/exceptions/plugin-not-found'));
}

var _componentNotFound;

function _load_componentNotFound() {
  return _componentNotFound = _interopRequireDefault(require('../scope/exceptions/component-not-found'));
}

var _permissionDenied;

function _load_permissionDenied() {
  return _permissionDenied = _interopRequireDefault(require('../scope/network/exceptions/permission-denied'));
}

var _networkError;

function _load_networkError() {
  return _networkError = _interopRequireDefault(require('../scope/network/exceptions/network-error'));
}

var _unexpectedNetworkError;

function _load_unexpectedNetworkError() {
  return _unexpectedNetworkError = _interopRequireDefault(require('../scope/network/exceptions/unexpected-network-error'));
}

var _missingImpl;

function _load_missingImpl() {
  return _missingImpl = _interopRequireDefault(require('../consumer/component/exceptions/missing-impl'));
}

var _mergeConflict;

function _load_mergeConflict() {
  return _mergeConflict = _interopRequireDefault(require('../scope/exceptions/merge-conflict'));
}

var _remoteNotFound;

function _load_remoteNotFound() {
  return _remoteNotFound = _interopRequireDefault(require('../remotes/exceptions/remote-not-found'));
}

var _exceptions2;

function _load_exceptions2() {
  return _exceptions2 = require('../scope/exceptions');
}

var _exceptions3;

function _load_exceptions3() {
  return _exceptions3 = require('../scope/network/exceptions');
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const chalk = require('chalk');

const errorsMap = [[(_exceptions || _load_exceptions()).ConsumerAlreadyExists, () => 'scope already exists... reinitialized.'], [(_exceptions || _load_exceptions()).ConsumerNotFound, () => 'fatal: scope not found. to create a new scope, please use `bit init`'], [(_bitNotFound || _load_bitNotFound()).default, () => 'fatal: component not found. to create a new bit, please use `bit create {bitName}`'], [(_bitAlreadyExistExternaly || _load_bitAlreadyExistExternaly()).default, err => `fatal: component "${err.bitName}" already exists in the external library try "bit modify ${err.bitName}" to modify the current component or "bit create -f ${err.bitName}"!`], [(_pluginNotFound || _load_pluginNotFound()).default, err => `fatal: The compiler "${err.plugin}" is not installed, please use "bit install ${err.plugin}" to install it.`], [(_missingImpl || _load_missingImpl()).default, err => `fatal: The impl file in path "${err.implPath}" does not exist, please check the bit.json or implementation file`], [(_exceptions3 || _load_exceptions3()).ProtocolNotSupported, () => 'fatal: remote scope protocol is not suppoerted, please use: `ssh://`, `file://` or `bit://`'], [(_exceptions3 || _load_exceptions3()).RemoteScopeNotFound, () => 'fatal: remote scope not found. to create a new scope, please use `bit init --bare` in the remote destination'], [(_invalidBitId || _load_invalidBitId()).default, () => 'fatal: component ID is invalid, please use the following format: <scope>/[box]/<name>'], [(_componentNotFound || _load_componentNotFound()).default, err => `fatal: component with id ${chalk.bold(err.id.toString())} was not found`], [(_permissionDenied || _load_permissionDenied()).default, () => 'fatal: permission to scope was denied'], [(_remoteNotFound || _load_remoteNotFound()).default, err => `fatal: remote '${chalk.bold(err.name)}' was not found`], [(_networkError || _load_networkError()).default, err => `fatal: remote failed with error: '${chalk.bold(err.remoteErr)}'`], [(_mergeConflict || _load_mergeConflict()).default, () => 'fatal: merge conflict'], [(_unexpectedNetworkError || _load_unexpectedNetworkError()).default, () => 'fatal: unexpected network error has occurred'], [(_exceptions2 || _load_exceptions2()).ScopeNotFound, () => 'fatal: scope not found. to create a new scope, please use `bit init --bare`'], [(_exceptions || _load_exceptions()).ComponentSpecsFailed, () => 'component\'s specs does not pass, fix them and commit'], [(_exceptions || _load_exceptions()).NothingToImport, () => 'there is nothing to import'], [(_exceptions2 || _load_exceptions2()).ResolutionException, e => e.message]];

exports.default = err => {
  const error = errorsMap.find((_ref) => {
    var _ref2 = _slicedToArray(_ref, 1);

    let ErrorType = _ref2[0];

    return err instanceof ErrorType;
  });
  if (!error) return null;

  var _error = _slicedToArray(error, 2);

  const func = _error[1];

  return chalk.red(func(err));
};