'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.paintDoc = undefined;

var _ramda;

function _load_ramda() {
  return _ramda = _interopRequireDefault(require('ramda'));
}

var _chalk;

function _load_chalk() {
  return _chalk = _interopRequireDefault(require('chalk'));
}

var _cliTable;

function _load_cliTable() {
  return _cliTable = _interopRequireDefault(require('cli-table2'));
}

var _chalkBox;

function _load_chalkBox() {
  return _chalkBox = require('../chalk-box');
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const paintExample = example => {
  return example.raw;
};

const paintExamples = examples => {
  if ((_ramda || _load_ramda()).default.isEmpty(examples) || (_ramda || _load_ramda()).default.isNil(examples)) {
    return '';
  }

  return `\n${(0, (_chalkBox || _load_chalkBox()).paintHeader)('Examples')}\n${examples.map(paintExample).join('\n')}`;
};

const paintDoc = exports.paintDoc = doc => {
  const docsTable = new (_cliTable || _load_cliTable()).default({
    colWidths: [20, 50],
    wordWrap: true
  });

  const name = doc.name,
        description = doc.description,
        args = doc.args,
        returns = doc.returns;


  const painArg = arg => {
    if (!arg.type && !arg.name) {
      return '';
    }
    if (!arg.type) {
      return `${arg.name}`;
    }
    return `${arg.name}: ${arg.type}`;
  };

  const painDescription = arg => {
    if (!arg.type) {
      return '';
    }
    if (arg.type && !arg.description) {
      return arg.type;
    }
    return `${arg.type} -> ${arg.description}`;
  };

  const rows = [name ? { [(_chalk || _load_chalk()).default.cyan('Name')]: name } : null, { [(_chalk || _load_chalk()).default.cyan('Description')]: description }, { [(_chalk || _load_chalk()).default.cyan('Args')]: `(${args.map(painArg).join(', ')})` }, { [(_chalk || _load_chalk()).default.cyan('Returns')]: painDescription(returns) }].filter(x => x);

  docsTable.push(...rows);

  return docsTable + paintExamples(doc.examples);
};

exports.default = docs => {
  if ((_ramda || _load_ramda()).default.isEmpty(docs) || (_ramda || _load_ramda()).default.isNil(docs)) {
    return 'No documentation found';
  }
  // $FlowFixMe
  return `\n${(0, (_chalkBox || _load_chalkBox()).paintHeader)('Documentation')}${docs.map(paintDoc).join('')}`;
};