'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _path;

function _load_path() {
  return _path = _interopRequireDefault(require('path'));
}

var _exceptions;

function _load_exceptions() {
  return _exceptions = _interopRequireDefault(require('./exceptions'));
}

var _constants;

function _load_constants() {
  return _constants = require('../../constants');
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

class BitInlineId {

  constructor(_ref) {
    let box = _ref.box,
        name = _ref.name;

    this.box = box || 'global';
    this.name = name;
  }

  composeBitPath(consumerDir) {
    return (_path || _load_path()).default.join(consumerDir, (_constants || _load_constants()).INLINE_BITS_DIRNAME, this.box, this.name);
  }

  toString() {
    const name = this.name,
          box = this.box;

    return [box, name].join('/');
  }

  static parse(id) {
    const splited = id.split('/');
    if (splited.length === 2) {
      var _splited = _slicedToArray(splited, 2);

      const box = _splited[0],
            name = _splited[1];

      return new BitInlineId({
        name,
        box
      });
    }

    if (splited.length === 1) {
      return new BitInlineId({ name: id });
    }

    throw new (_exceptions || _load_exceptions()).default();
  }
}
exports.default = BitInlineId;