'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _path;

function _load_path() {
  return _path = _interopRequireDefault(require('path'));
}

var _fs;

function _load_fs() {
  return _fs = _interopRequireDefault(require('fs'));
}

var _bitJson;

function _load_bitJson() {
  return _bitJson = _interopRequireDefault(require('../bit-json'));
}

var _constants;

function _load_constants() {
  return _constants = require('../../constants');
}

var _envBitNotExists;

function _load_envBitNotExists() {
  return _envBitNotExists = _interopRequireDefault(require('./exceptions/env-bit-not-exists'));
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = (bitPath, opts) => {
  if (!(_fs || _load_fs()).default.existsSync(bitPath)) throw new (_envBitNotExists || _load_envBitNotExists()).default();

  const distFile = (_path || _load_path()).default.join(bitPath, (_constants || _load_constants()).DEFAULT_DIST_DIRNAME, (_constants || _load_constants()).DEFAULT_BUNDLE_FILENAME);
  if ((_fs || _load_fs()).default.existsSync(distFile)) {
    try {
      // $FlowFixMe
      return require(distFile);
    } catch (e) {
      throw e;
    }
  }

  const bitJson = (_bitJson || _load_bitJson()).default.loadSync(bitPath);
  const implFile = (_path || _load_path()).default.join(bitPath, bitJson.getImplBasename());
  try {
    if (opts && opts.onlyPath) return implFile;
    // $FlowFixMe
    return require(implFile);
  } catch (e) {
    throw e;
  }
};