'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _fsExtra;

function _load_fsExtra() {
  return _fsExtra = _interopRequireWildcard(require('fs-extra'));
}

var _path;

function _load_path() {
  return _path = _interopRequireWildcard(require('path'));
}

var _source;

function _load_source() {
  return _source = _interopRequireDefault(require('./source'));
}

var _constants;

function _load_constants() {
  return _constants = require('../../../constants');
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

class Dist extends (_source || _load_source()).default {
  write(bitPath) {
    const filePath = (_path || _load_path()).join(bitPath, (_constants || _load_constants()).DEFAULT_DIST_DIRNAME, (_constants || _load_constants()).DEFAULT_BUNDLE_FILENAME);
    return new Promise((resolve, reject) => (_fsExtra || _load_fsExtra()).outputFile(filePath, this.src, err => {
      if (err) return reject(err);
      return resolve(filePath);
    }));
  }

  serialize() {
    return this.src;
  }

  static deserialize(str) {
    return new Dist(str);
  }
}
exports.default = Dist;