'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _path;

function _load_path() {
  return _path = _interopRequireDefault(require('path'));
}

var _constants;

function _load_constants() {
  return _constants = require('../constants');
}

var _utils;

function _load_utils() {
  return _utils = require('../utils');
}

var _remotes;

function _load_remotes() {
  return _remotes = require('../remotes');
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

class GlobalRemotes {

  constructor(remotes) {
    this.remotes = remotes;
  }

  addRemote(remote) {
    this.remotes[remote.name] = remote.host;
    return this;
  }

  rmRemote(name) {
    delete this.remotes[name];
    return this;
  }

  toJson() {
    let readable = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : true;

    if (!readable) return JSON.stringify(this.toPlainObject());
    return JSON.stringify(this.toPlainObject(), null, 4);
  }

  asRemotes() {
    return (_remotes || _load_remotes()).Remotes.load(this.remotes);
  }

  toPlainObject() {
    return this.remotes;
  }

  write() {
    return (0, (_utils || _load_utils()).writeFile)((_path || _load_path()).default.join((_constants || _load_constants()).GLOBAL_CONFIG, (_constants || _load_constants()).GLOBAL_REMOTES), this.toJson());
  }

  static load() {
    return (0, (_utils || _load_utils()).readFile)((_path || _load_path()).default.join((_constants || _load_constants()).GLOBAL_CONFIG, (_constants || _load_constants()).GLOBAL_REMOTES)).then(contents => new GlobalRemotes(JSON.parse(contents.toString('utf8')))).catch(err => {
      if (err.code !== 'ENOENT') return err;
      const globalRemotes = new GlobalRemotes({});
      return globalRemotes.write().then(() => globalRemotes);
    });
  }
}
exports.default = GlobalRemotes;