'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _ramda;

function _load_ramda() {
  return _ramda = _interopRequireDefault(require('ramda'));
}

var _globalConfig;

function _load_globalConfig() {
  return _globalConfig = require('../api/consumer/lib/global-config');
}

var _client;

function _load_client() {
  return _client = _interopRequireDefault(require('./http-client/client'));
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const createHook = (hookNameKey, methodName) => {
  methodName = (_ramda || _load_ramda()).default.toUpper(methodName);
  return data => {
    return new Promise(resolve => {
      return (0, (_globalConfig || _load_globalConfig()).get)(hookNameKey).then(destUrl => {
        if (!destUrl) return resolve();

        return (_client || _load_client()).default[methodName](destUrl, data).then(() => resolve()).catch(() => resolve());
      });
    });
  };
};
exports.default = createHook;