'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _ramda;

function _load_ramda() {
  return _ramda = _interopRequireDefault(require('ramda'));
}

var _scope;

function _load_scope() {
  return _scope = _interopRequireDefault(require('../../scope/scope'));
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const hubResolver = scopeName => {
  const hubPrefix = 'ssh://bit@hub.bitsrc.io:';
  return Promise.resolve(hubPrefix + scopeName);
};

const remoteResolver = (scopeName, thisScope) => {
  const resolverPath = (_ramda || _load_ramda()).default.path(['scopeJson', 'resolverPath'], thisScope);
  let resolverFunction;
  if (!resolverPath) resolverFunction = hubResolver;
  // $FlowFixMe
  else resolverFunction = require(resolverPath);

  return resolverFunction(scopeName, thisScope.name);
};

exports.default = remoteResolver;