'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _path;

function _load_path() {
  return _path = _interopRequireDefault(require('path'));
}

var _bitId;

function _load_bitId() {
  return _bitId = require('../../bit-id');
}

var _component;

function _load_component() {
  return _component = _interopRequireDefault(require('../../consumer/component'));
}

var _dependencyMap;

function _load_dependencyMap() {
  return _dependencyMap = require('./dependency-map');
}

var _constants;

function _load_constants() {
  return _constants = require('../../constants');
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

class SourcesDependencyMap extends (_dependencyMap || _load_dependencyMap()).DependencyMap {
  getPath() {
    return (_path || _load_path()).default.join(this.repository.getPath(), (_constants || _load_constants()).SOURCES_MAP);
  }

  get(bitId) {
    return super.get(bitId.toString(true));
  }

  setBit(id, bits) {
    super.set(id.toString(true), new (_bitId || _load_bitId()).BitIds(...bits.map(bit => bit.getId())));
    return this;
  }

  toObject() {
    const obj = {};
    this.forEach((bitIds, bitId) => {
      obj[bitId.toString(true)] = bitIds.map(dependency => dependency.toString());
    });
    return obj;
  }
}
exports.default = SourcesDependencyMap;