'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = keyGetter;

var _fs;

function _load_fs() {
  return _fs = _interopRequireWildcard(require('fs'));
}

var _globalConfig;

function _load_globalConfig() {
  return _globalConfig = require('../../../api/consumer/lib/global-config');
}

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

const userHome = require('user-home');

function getPathToIdentityFile() {
  const identityFile = (0, (_globalConfig || _load_globalConfig()).getSync)('ssh_key_file');
  return identityFile || `${userHome}/.ssh/id_rsa`;
}

function keyGetter(keyPath) {
  if (keyPath) return (_fs || _load_fs()).readFileSync(keyPath);
  return (_fs || _load_fs()).readFileSync(getPathToIdentityFile());
}