'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _repository;

function _load_repository() {
  return _repository = _interopRequireDefault(require('./repository'));
}

var _object;

function _load_object() {
  return _object = _interopRequireDefault(require('./object'));
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

class Ref {

  constructor(hash) {
    this.hash = hash;
  }

  toString() {
    return this.hash;
  }

  load(repository) {
    return repository.findOne(this);
  }

  loadSync(repo) {
    return repo.loadSync(this);
  }

  loadRaw(repo) {
    return repo.loadRaw(this);
  }

  static from(hash) {
    return new Ref(hash);
  }
}
exports.default = Ref;