'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _componentDependencies;

function _load_componentDependencies() {
  return _componentDependencies = _interopRequireDefault(require('./component-dependencies'));
}

var _componentVersion;

function _load_componentVersion() {
  return _componentVersion = _interopRequireDefault(require('./component-version'));
}

var _componentObjects;

function _load_componentObjects() {
  return _componentObjects = _interopRequireDefault(require('./component-objects'));
}

var _repository;

function _load_repository() {
  return _repository = _interopRequireDefault(require('./objects/repository'));
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

class VersionDependencies {

  constructor(component, dependencies, sourceScope) {
    this.component = component;
    this.dependencies = dependencies;
    this.sourceScope = sourceScope;
  }

  toConsumer(repo) {
    const dependenciesP = Promise.all(this.dependencies.map(dep => dep.toConsumer(repo)));
    const componentP = this.component.toConsumer(repo);
    return Promise.all([componentP, dependenciesP]).then((_ref) => {
      var _ref2 = _slicedToArray(_ref, 2);

      let component = _ref2[0],
          dependencies = _ref2[1];
      return new (_componentDependencies || _load_componentDependencies()).default({
        component,
        dependencies
      });
    });
  }

  toObjects(repo) {
    const depsP = Promise.all(this.dependencies.map(dep => dep.toObjects(repo)));
    const compP = this.component.toObjects(repo);

    return Promise.all([compP, depsP]).then((_ref3) => {
      var _ref4 = _slicedToArray(_ref3, 2);

      let component = _ref4[0],
          dependencies = _ref4[1];

      const flattened = dependencies.reduce((array, compObjects) => {
        array.push(...compObjects.objects.concat([compObjects.component]));
        return array;
      }, []);

      return new (_componentObjects || _load_componentObjects()).default(component.component, flattened.concat(component.objects));
    });
  }
}
exports.default = VersionDependencies;