'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _child_process;

function _load_child_process() {
  return _child_process = require('child_process');
}

var _path;

function _load_path() {
  return _path = _interopRequireDefault(require('path'));
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = (_ref) => {
  let name = _ref.name,
      version = _ref.version,
      dir = _ref.dir;
  var _ref$silent = _ref.silent;
  let silent = _ref$silent === undefined ? true : _ref$silent;

  return new Promise((resolve, reject) => {
    const child = (0, (_child_process || _load_child_process()).fork)((_path || _load_path()).default.join(__dirname, 'npm-worker.js'), {
      silent,
      env: {
        __name__: name,
        __version__: version,
        __dir__: dir
      }
    });

    process.on('exit', () => {
      child.kill('SIGKILL');
    });

    child.on('message', (_ref2) => {
      let type = _ref2.type,
          payload = _ref2.payload;

      if (type === 'error') return reject(payload);
      return resolve(payload);
    });

    child.on('error', e => {
      reject(e);
    });
  });
};