'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = build;

var _consumer;

function _load_consumer() {
  return _consumer = require('../../../consumer');
}

var _component;

function _load_component() {
  return _component = _interopRequireDefault(require('../../../consumer/component'));
}

var _bitInlineId;

function _load_bitInlineId() {
  return _bitInlineId = _interopRequireDefault(require('../../../consumer/bit-inline-id'));
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function build(id) {
  const inlineId = (_bitInlineId || _load_bitInlineId()).default.parse(id);
  return (0, (_consumer || _load_consumer()).loadConsumer)().then(consumer => {
    return consumer.loadComponent(inlineId).then(component => {
      component.build(consumer.scope);
      const bitPath = inlineId.composeBitPath(consumer.getPath());
      return component.dist ? component.dist.write(bitPath) : null;
    });
  });
}
//# sourceMappingURL=build-inline.js.map