'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = modify;

var _consumer;

function _load_consumer() {
  return _consumer = require('../../../consumer');
}

var _bitId;

function _load_bitId() {
  return _bitId = require('../../../bit-id');
}

var _bitInlineId;

function _load_bitInlineId() {
  return _bitInlineId = _interopRequireDefault(require('../../../consumer/bit-inline-id'));
}

var _scope;

function _load_scope() {
  return _scope = require('../../../scope');
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function modify(_ref) {
  let id = _ref.id,
      loader = _ref.loader;

  return (0, (_consumer || _load_consumer()).loadConsumer)().then(consumer => {
    const bitId = (_bitId || _load_bitId()).BitId.parse(id, consumer.scope.name);
    loader.start();

    return consumer.scope.modify(bitId).then(c => {
      const inlineId = new (_bitInlineId || _load_bitInlineId()).default({ box: bitId.box, name: bitId.name });
      const inlineBitPath = inlineId.composeBitPath(consumer.getPath());

      return c.component.write(inlineBitPath, true);
    });
  });
}
//# sourceMappingURL=modify.js.map