'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = fetch;

var _scope;

function _load_scope() {
  return _scope = require('../../../scope');
}

var _bitId;

function _load_bitId() {
  return _bitId = require('../../../bit-id');
}

function fetch(path, ids) {
  let noDependencies = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;

  return (0, (_scope || _load_scope()).loadScope)(path).then(scope => {
    const bitIds = (_bitId || _load_bitId()).BitIds.deserialize(ids);
    if (noDependencies) return scope.manyOneObjects(bitIds);
    return scope.getObjects(bitIds);
  });
}
//# sourceMappingURL=fetch.js.map