'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _ramda;

function _load_ramda() {
  return _ramda = _interopRequireDefault(require('ramda'));
}

var _command;

function _load_command() {
  return _command = _interopRequireDefault(require('../../command'));
}

var _consumer;

function _load_consumer() {
  return _consumer = require('../../../api/consumer');
}

var _utils;

function _load_utils() {
  return _utils = require('../../../utils');
}

var _chalkBox;

function _load_chalkBox() {
  return _chalkBox = require('../../chalk-box');
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

class Import extends (_command || _load_command()).default {
  constructor() {
    var _temp;

    return _temp = super(...arguments), this.name = 'import [ids]', this.description = 'import a component', this.alias = 'i', this.opts = [['s', 'save', 'save into bit.json'], ['t', 'tester', 'import a tester environment component'], ['v', 'verbose', 'show a more verbose output when possible'], ['c', 'compiler', 'import a compiler environment component'], ['p', 'prefix', 'import components into a specific directory'], ['d', 'dev', 'also import dev dependencies (compiler | tester)']], this.loader = { autoStart: false, text: 'importing components' }, _temp;
  }

  action(_ref, _ref2) {
    var _ref3 = _slicedToArray(_ref, 1);

    let id = _ref3[0];
    let save = _ref2.save,
        tester = _ref2.tester,
        compiler = _ref2.compiler,
        verbose = _ref2.verbose,
        prefix = _ref2.prefix,
        dev = _ref2.dev;

    if (prefix) {
      return Promise.reject(new Error('prefix option currently not supported'));
    }
    // TODO - prefix returns true instead of the relevant string.
    const loader = this.loader;
    // @TODO - import should support multiple components
    if (tester && compiler) {
      throw new Error('you cant use tester and compiler flags combined');
    }

    return (0, (_consumer || _load_consumer()).importAction)({ bitId: id, save, tester, compiler, loader, verbose, prefix, dev });
  }

  report(components) {
    if ((_ramda || _load_ramda()).default.isEmpty(components)) {
      return 'done';
    }
    return (0, (_utils || _load_utils()).immutableUnshift)(components.map((_chalkBox || _load_chalkBox()).formatBit), (0, (_chalkBox || _load_chalkBox()).paintHeader)('imported the following components:')).join('\n');
  }
}
exports.default = Import;
//# sourceMappingURL=import-cmd.js.map