'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _chalk;

function _load_chalk() {
  return _chalk = _interopRequireDefault(require('chalk'));
}

var _path;

function _load_path() {
  return _path = _interopRequireWildcard(require('path'));
}

var _command;

function _load_command() {
  return _command = _interopRequireDefault(require('../../command'));
}

var _scope;

function _load_scope() {
  return _scope = require('../../../api/scope');
}

var _consumer;

function _load_consumer() {
  return _consumer = require('../../../api/consumer');
}

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

class Init extends (_command || _load_command()).default {
  constructor() {
    var _temp;

    return _temp = super(...arguments), this.name = 'init [path]', this.description = 'initialize an empty bit scope', this.alias = '', this.opts = [['b', 'bare [name]', 'initialize an empty bit bare scope'], ['s', 'shared <groupname>', 'add group write permissions to a scope properly']], _temp;
  }

  action(_ref, _ref2) {
    var _ref3 = _slicedToArray(_ref, 1);

    let path = _ref3[0];
    let bare = _ref2.bare,
        shared = _ref2.shared;

    if (path) path = (_path || _load_path()).resolve(path);

    if (bare) {
      if (typeof bare === 'boolean') bare = '';
      return (0, (_scope || _load_scope()).initScope)(path, bare, shared).then((_ref4) => {
        let created = _ref4.created;

        return {
          created,
          bare: true
        };
      });
    }

    return (0, (_consumer || _load_consumer()).init)(path).then((_ref5) => {
      let created = _ref5.created;

      return {
        created
      };
    });
  }

  report(_ref6) {
    let created = _ref6.created,
        bare = _ref6.bare;

    if (bare) {
      // if (!created) return `${chalk.grey('successfully reinitialized a bare bit scope.')}`;
      // @TODO - a case that you already have a bit scope
      return `${(_chalk || _load_chalk()).default.green('successfully initialized an empty bare bit scope.')}`;
    }

    if (!created) return `${(_chalk || _load_chalk()).default.grey('successfully reinitialized a bit scope.')}`;
    return `${(_chalk || _load_chalk()).default.green('successfully initialized an empty bit scope.')}`;
  }
}
exports.default = Init;
//# sourceMappingURL=init-cmd.js.map