'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _chalk;

function _load_chalk() {
  return _chalk = _interopRequireDefault(require('chalk'));
}

var _command;

function _load_command() {
  return _command = _interopRequireDefault(require('../../command'));
}

var _consumer;

function _load_consumer() {
  return _consumer = require('../../../api/consumer');
}

var _component;

function _load_component() {
  return _component = _interopRequireDefault(require('../../../consumer/component'));
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

class Modify extends (_command || _load_command()).default {
  constructor() {
    var _temp;

    return _temp = super(...arguments), this.name = 'modify <id>', this.description = 'modify a component (transfer to the inline directory for modification)', this.alias = 'm', this.opts = [], this.loader = { autoStart: false, text: 'importing components' }, _temp;
  }

  action(_ref) {
    var _ref2 = _slicedToArray(_ref, 1);

    let id = _ref2[0];

    const loader = this.loader;
    return (0, (_consumer || _load_consumer()).modify)({ id, loader }).then(component => {
      return {
        name: component.name,
        box: component.box
      };
    });
  }

  report(_ref3) {
    let name = _ref3.name,
        box = _ref3.box;

    return (_chalk || _load_chalk()).default.white('put ') + (_chalk || _load_chalk()).default.magenta(`"${box}/${name}"`) + (_chalk || _load_chalk()).default.white(' in inline_components directory for later modification');
  }
}
exports.default = Modify;
//# sourceMappingURL=modify-cmd.js.map