'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _ramda;

function _load_ramda() {
  return _ramda = _interopRequireDefault(require('ramda'));
}

var _command;

function _load_command() {
  return _command = _interopRequireDefault(require('../../command'));
}

var _consumer;

function _load_consumer() {
  return _consumer = require('../../../api/consumer');
}

var _componentTemplate;

function _load_componentTemplate() {
  return _componentTemplate = _interopRequireDefault(require('../../templates/component-template'));
}

var _component;

function _load_component() {
  return _component = _interopRequireDefault(require('../../../consumer/component'));
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

class Show extends (_command || _load_command()).default {
  constructor() {
    var _temp;

    return _temp = super(...arguments), this.name = 'show <id>', this.description = 'show a component', this.alias = '', this.opts = [['i', 'inline', 'show inline component'], ['j', 'json', 'return a json version of the component'], ['ver', 'versions', 'return a json of all the versions of the component']], this.loader = { autoStart: false, text: 'fetching remote component' }, _temp;
  }

  action(_ref, _ref2) {
    var _ref3 = _slicedToArray(_ref, 1);

    let id = _ref3[0];
    let inline = _ref2.inline,
        json = _ref2.json,
        versions = _ref2.versions;

    const loader = this.loader;

    function getBitComponent(allVersions) {
      if (inline) return (0, (_consumer || _load_consumer()).getInlineBit)({ id });
      return (0, (_consumer || _load_consumer()).getScopeBit)({ id, loader, allVersions });
    }

    if (versions) {
      return getBitComponent(versions).then(components => ({
        components,
        versions
      }));
    }

    return getBitComponent().then(component => ({
      component,
      json
    }));
  }

  report(_ref4) {
    let component = _ref4.component,
        json = _ref4.json,
        versions = _ref4.versions,
        components = _ref4.components;

    if (versions) {
      if ((_ramda || _load_ramda()).default.isNil(components) || (_ramda || _load_ramda()).default.isEmpty(components)) {
        return 'could not find the requested component';
      }
      // $FlowFixMe
      return JSON.stringify(components.map(c => c.toObject()));
    }

    if (!component) return 'could not find the requested component';
    return json ? component.toString() : (0, (_componentTemplate || _load_componentTemplate()).default)(component);
  }
}
exports.default = Show;
//# sourceMappingURL=show-cmd.js.map