'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _chalk;

function _load_chalk() {
  return _chalk = _interopRequireDefault(require('chalk'));
}

var _command;

function _load_command() {
  return _command = _interopRequireDefault(require('../../command'));
}

var _consumer;

function _load_consumer() {
  return _consumer = require('../../../api/consumer');
}

var _utils;

function _load_utils() {
  return _utils = require('../../../utils');
}

var _chalkBox;

function _load_chalkBox() {
  return _chalkBox = require('../../chalk-box');
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

class Status extends (_command || _load_command()).default {
  constructor() {
    var _temp;

    return _temp = super(...arguments), this.name = 'status', this.description = 'show modifications status', this.alias = 's', this.opts = [], _temp;
  }

  action() {
    const getBitStatusForInline = bit => ({
      name: bit.name,
      box: bit.box
    });

    const getBitStatusForSources = bit => ({
      name: bit.name,
      box: bit.box,
      // valid: bit.validate(),
      version: bit.version
    });

    return (0, (_consumer || _load_consumer()).status)().then((_ref) => {
      let inline = _ref.inline,
          sources = _ref.sources;

      return {
        inline: inline.map(getBitStatusForInline),
        sources: sources.map(getBitStatusForSources)
      };
    });
  }

  report(_ref2) {
    let inline = _ref2.inline,
        sources = _ref2.sources;

    const inlineBits = (0, (_utils || _load_utils()).immutableUnshift)(inline.map((_chalkBox || _load_chalkBox()).formatInlineBit), inline.length ? (_chalk || _load_chalk()).default.underline.white('inline components') : (_chalk || _load_chalk()).default.green('your inline_component directory is empty')).join('\n');

    const sourcesBits = (0, (_utils || _load_utils()).immutableUnshift)(sources.map((_chalkBox || _load_chalkBox()).formatBit), sources.length ? (_chalk || _load_chalk()).default.underline.white('sources waiting for export') : (_chalk || _load_chalk()).default.green('you don\'t have any sources to export')).join('\n');

    return [inlineBits, sourcesBits].join((_chalk || _load_chalk()).default.underline('\n                         \n') + (_chalk || _load_chalk()).default.white('\n'));
  }
}
exports.default = Status;
//# sourceMappingURL=status-cmd.js.map