'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _ramda;

function _load_ramda() {
  return _ramda = _interopRequireDefault(require('ramda'));
}

var _chalk;

function _load_chalk() {
  return _chalk = _interopRequireDefault(require('chalk'));
}

var _cliTable;

function _load_cliTable() {
  return _cliTable = _interopRequireDefault(require('cli-table2'));
}

var _consumerComponent;

function _load_consumerComponent() {
  return _consumerComponent = _interopRequireDefault(require('../../consumer/component/consumer-component'));
}

var _docsTemplate;

function _load_docsTemplate() {
  return _docsTemplate = _interopRequireDefault(require('./docs-template'));
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = component => {
  const table = new (_cliTable || _load_cliTable()).default({
    colWidths: [20, 50],
    wordWrap: true
  });

  const name = component.name,
        box = component.box,
        compilerId = component.compilerId,
        testerId = component.testerId,
        dependencies = component.dependencies,
        packageDependencies = component.packageDependencies,
        docs = component.docs;


  const rows = [{ [(_chalk || _load_chalk()).default.cyan('ID')]: `${box}/${name}` }, compilerId ? { [(_chalk || _load_chalk()).default.cyan('Compiler')]: compilerId.toString() } : null, testerId ? { [(_chalk || _load_chalk()).default.cyan('Tester')]: testerId.toString() } : null, !(_ramda || _load_ramda()).default.isEmpty(dependencies) ? { [(_chalk || _load_chalk()).default.cyan('Dependencies')]: dependencies.map(id => id.toString()).join(', ') } : null, !(_ramda || _load_ramda()).default.isEmpty(packageDependencies) ? { [(_chalk || _load_chalk()).default.cyan('Packages')]: Object.keys(packageDependencies).join(', ') } : null].filter(x => x);

  table.push(...rows);

  return table.toString() + (0, (_docsTemplate || _load_docsTemplate()).default)(docs);
};
//# sourceMappingURL=component-template.js.map