'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _chalk;

function _load_chalk() {
  return _chalk = _interopRequireDefault(require('chalk'));
}

var _cliTable;

function _load_cliTable() {
  return _cliTable = _interopRequireDefault(require('cli-table2'));
}

var _consumerComponent;

function _load_consumerComponent() {
  return _consumerComponent = _interopRequireDefault(require('../../consumer/component/consumer-component'));
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = components => {
  const table = new (_cliTable || _load_cliTable()).default({
    head: [(_chalk || _load_chalk()).default.cyan('ID'), (_chalk || _load_chalk()).default.cyan('Version')],
    colWidths: [46, 9],
    wordWrap: true
  });

  function tablizeComponent(component) {
    return [`${component.box}/${component.name}`, component.version]; // Add date, author 
  }

  table.push(...components.map(tablizeComponent));
  return table.toString();
};
//# sourceMappingURL=list-template.js.map