'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _fs;

function _load_fs() {
  return _fs = _interopRequireWildcard(require('fs'));
}

var _path;

function _load_path() {
  return _path = _interopRequireWildcard(require('path'));
}

var _source;

function _load_source() {
  return _source = _interopRequireDefault(require('./source'));
}

var _bitId;

function _load_bitId() {
  return _bitId = _interopRequireDefault(require('../../../bit-id'));
}

var _specs;

function _load_specs() {
  return _specs = _interopRequireDefault(require('../templates/specs.default-template'));
}

var _scope;

function _load_scope() {
  return _scope = require('../../../scope');
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

class Specs extends (_source || _load_source()).default {
  write(bitPath, fileName) {
    return new Promise((resolve, reject) => {
      (_fs || _load_fs()).writeFile((_path || _load_path()).join(bitPath, fileName), this.src, (err, res) => {
        if (err) return reject(err);
        return resolve(res);
      });
    });
  }

  serialize() {
    return this.src;
  }

  static deserialize(str) {
    return new Specs(str);
  }

  static load(specsPath) {
    try {
      const data = (_fs || _load_fs()).readFileSync(specsPath);
      return new Specs(data.toString());
    } catch (err) {
      return null; // when cant load specs it's ok, just return undefined';
    }
  }

  static create(name, testerId, scope) {
    function getTemplate() {
      try {
        const testerModule = scope.loadEnvironment(testerId);
        return testerModule.getTemplate(name);
      } catch (e) {
        return (0, (_specs || _load_specs()).default)({ name });
      }
    }

    return new Specs(getTemplate());
  }
}
exports.default = Specs;
//# sourceMappingURL=specs.js.map