"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
class SpecsResults {

  constructor(_ref) {
    let tests = _ref.tests,
        stats = _ref.stats,
        pass = _ref.pass;

    this.tests = tests;
    this.stats = stats;
    this.pass = pass;
  }

  serialize() {
    return {
      tests: this.tests,
      stats: this.stats,
      pass: this.pass
    };
  }

  static deserialize(plainObject) {
    return new SpecsResults(plainObject);
  }

  static createFromRaw(rawResults) {
    const pass = rawResults.pass || rawResults.tests.every(test => test.pass);

    const calcDuration = (endDateString, startDateString) => new Date(endDateString) - new Date(startDateString);

    const stats = {
      start: rawResults.stats.start,
      end: rawResults.stats.end,
      duration: parseInt(rawResults.stats.duration) || calcDuration(rawResults.stats.end, rawResults.stats.start)
    };

    const tests = rawResults.tests.map(result => {
      result.duration = parseInt(result.duration);
      // $FlowFixMe
      return result;
    });

    return new SpecsResults({ tests, stats, pass });
  }
}
exports.default = SpecsResults;
//# sourceMappingURL=specs-results.js.map