'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _scope;

function _load_scope() {
  return _scope = require('../scope');
}

var _bitId;

function _load_bitId() {
  return _bitId = require('../bit-id');
}

var _constants;

function _load_constants() {
  return _constants = require('../constants');
}

var _component;

function _load_component() {
  return _component = _interopRequireDefault(require('../consumer/component'));
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

class LocalScope {

  constructor(scope) {
    this.scope = scope;
    this.host = (_constants || _load_constants()).LOCAL_SCOPE_NOTATION;
  }

  fetch(bitIds) {
    const promises = bitIds.map(bitId => this.scope.get(bitId));
    return Promise.all(promises);
  }

  getHost() {
    return this.host;
  }

  toPlainObject() {
    return {
      alias: (_constants || _load_constants()).LOCAL_SCOPE_NOTATION
    };
  }
}
exports.default = LocalScope;
//# sourceMappingURL=local-scope.js.map