'use strict';

var _chai;

function _load_chai() {
  return _chai = require('chai');
}

var _sinon;

function _load_sinon() {
  return _sinon = _interopRequireDefault(require('sinon'));
}

var _searchIndex;

function _load_searchIndex() {
  return _searchIndex = _interopRequireDefault(require('search-index'));
}

var _serverlessIndex;

function _load_serverlessIndex() {
  return _serverlessIndex = _interopRequireDefault(require('../../src/search/serverless-index'));
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('SeverLessIndex', () => {
  describe('initializeIndex', () => {
    it('should initial the index using search-index lib with some default settings', () => {
      // this hack was taken from: https://github.com/sinonjs/sinon/issues/562#issuecomment-164522794
      // it is needed because search-index library returns a function, not object.
      const myStubbedModule = moduleName => {
        const stub = (_sinon || _load_sinon()).default.stub();
        require.cache[require.resolve(moduleName)] = {
          default: stub,
          exports: stub
        };
        return stub;
      };
      myStubbedModule('search-index');
      const result = (_serverlessIndex || _load_serverlessIndex()).default.initializeIndex('test_path');

      (_sinon || _load_sinon()).default.assert.calledWith((_searchIndex || _load_searchIndex()).default, {
        indexPath: "test_path/search_index",
        logLevel: "error",
        stopwords: []
      });
      (0, (_chai || _load_chai()).expect)(result).to.be.a('Promise');
    });
  });
});
//# sourceMappingURL=serverless-index.spec.js.map