'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.pathHas = pathHas;
exports.propogateUntil = propogateUntil;

var _path;

function _load_path() {
  return _path = _interopRequireWildcard(require('path'));
}

var _fs;

function _load_fs() {
  return _fs = _interopRequireWildcard(require('fs'));
}

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function composePath(patternPath, patterns) {
  return patterns.map(pattern => {
    return (_path || _load_path()).join(patternPath, pattern);
  });
}

/**
 * determine whether given path has a container
 */
function pathHas(patterns) {
  return absPath => {
    let state = false;
    const paths = composePath(absPath, patterns);
    for (const potentialPath of paths) {
      if (state) return state;
      state = (_fs || _load_fs()).existsSync(potentialPath);
    }

    return state;
  };
}

function propogateUntil(fromPath, pattern) {
  function buildPropogationPaths() {
    const paths = [];
    const pathParts = fromPath.split((_path || _load_path()).sep);

    pathParts.forEach((val, index) => {
      const part = pathParts.slice(0, index).join('/');
      if (!part) return;
      paths.push(part);
    });

    return paths.reverse();
  }

  if (pattern(fromPath)) return fromPath;
  const searchPaths = buildPropogationPaths();
  return searchPaths.find(searchPath => pattern(searchPath));
}
//# sourceMappingURL=fs-propogate-until.js.map