"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = promisify;
function promisify(fn) {
  return function () {
    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return new Promise((resolve, reject) => {
      fn(...args, (err, res) => {
        if (err) return reject(err);
        return resolve(res);
      });
    });
  };
}
//# sourceMappingURL=promisify.js.map