'use strict';

var _chai;

function _load_chai() {
  return _chai = require('chai');
}

var _versionParser;

function _load_versionParser() {
  return _versionParser = _interopRequireDefault(require('./version-parser'));
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('versionParser()', () => {
  it('should return latest verion reprenestation', () => {
    const version = (0, (_versionParser || _load_versionParser()).default)('latest');
    (0, (_chai || _load_chai()).expect)(version.latest).to.equal(true);
    (0, (_chai || _load_chai()).expect)(version.versionNum).to.equal(null);
  });

  it('should throw invalid version', () => {
    (0, (_chai || _load_chai()).expect)(() => {
      (0, (_versionParser || _load_versionParser()).default)('$1');
    }).to.throw();
  });

  it('should return a concerete version', () => {
    const version = (0, (_versionParser || _load_versionParser()).default)('1');
    (0, (_chai || _load_chai()).expect)(version.latest).to.equal(false);
    (0, (_chai || _load_chai()).expect)(version.versionNum).to.equal(1);
  });

  it('should return a latest tested version', () => {
    const version = (0, (_versionParser || _load_versionParser()).default)('*1');
    (0, (_chai || _load_chai()).expect)(version.latest).to.equal(true);
    (0, (_chai || _load_chai()).expect)(version.versionNum).to.equal(1);
  });

  it('should return a latest tested version with double digits', () => {
    const version = (0, (_versionParser || _load_versionParser()).default)('*11');
    (0, (_chai || _load_chai()).expect)(version.latest).to.equal(true);
    (0, (_chai || _load_chai()).expect)(version.versionNum).to.equal(11);
  });
});
//# sourceMappingURL=version-parser.spec.js.map